/*
	Vertris v0.3.2
	Copyright (C) 2006 - 2007, Andrs Rassol
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <string.h>

#include <allegro.h>

#include "vertris.h"

extern Vertromino Vertro;
Vertromino Vertro_Next;

char Next_Vertro;

void set_vertro(char type, char dir)
{
	memset(Vertro.shape, 0, MAX_VERTROMINO * MAX_VERTROMINO);

	Vertro.type = type;
	Vertro.dir = dir;

	switch (type)
	{
		case 'I':
			if (dir % 2 == 0)
			{
				Vertro.shape[1][0] = 'I'; // .I..
				Vertro.shape[1][1] = 'I'; // .I..
				Vertro.shape[1][2] = 'I'; // .I..
				Vertro.shape[1][3] = 'I'; // .I..
			}
			else if (dir % 2 == 1)
			{
				Vertro.shape[0][2] = 'I'; // ....
				Vertro.shape[1][2] = 'I'; // IIII
				Vertro.shape[2][2] = 'I'; // ....
				Vertro.shape[3][2] = 'I'; // ....
			}
			break;
		case 'T':
			if (dir == 0)
			{
				Vertro.shape[0][1] = 'T'; // ....
				Vertro.shape[1][1] = 'T'; // .T..
				Vertro.shape[1][2] = 'T'; // TTT.
				Vertro.shape[2][1] = 'T'; // ....
			}
			else if (dir == 1)
			{
				Vertro.shape[0][1] = 'T'; // ....
				Vertro.shape[1][0] = 'T'; // .T..
				Vertro.shape[1][1] = 'T'; // TT..
				Vertro.shape[1][2] = 'T'; // .T..
			}
			else if (dir == 2)
			{
				Vertro.shape[0][1] = 'T'; // ....
				Vertro.shape[1][0] = 'T'; // ....
				Vertro.shape[1][1] = 'T'; // TTT.
				Vertro.shape[2][1] = 'T'; // .T..
			}
			else if (dir == 3)
			{
				Vertro.shape[1][0] = 'T'; // ....
				Vertro.shape[1][1] = 'T'; // .T..
				Vertro.shape[1][2] = 'T'; // .TT.
				Vertro.shape[2][1] = 'T'; // .T..
			}
			break;
		case 'O':
			Vertro.shape[0][0] = 'O'; // ....
			Vertro.shape[0][1] = 'O'; // ....
			Vertro.shape[1][0] = 'O'; // OO..
			Vertro.shape[1][1] = 'O'; // OO..
			break;
		case 'L':
			if (dir == 0)
			{
				Vertro.shape[1][0] = 'L'; // ....
				Vertro.shape[1][1] = 'L'; // .L..
				Vertro.shape[1][2] = 'L'; // .L..
				Vertro.shape[2][0] = 'L'; // .LL.
			}
			else if (dir == 1)
			{
				Vertro.shape[0][1] = 'L'; // ....
				Vertro.shape[1][1] = 'L'; // ..L.
				Vertro.shape[2][1] = 'L'; // LLL.
				Vertro.shape[2][2] = 'L'; // ....
			}
			else if (dir == 2)
			{
				Vertro.shape[0][2] = 'L'; // ....
				Vertro.shape[1][0] = 'L'; // LL..
				Vertro.shape[1][1] = 'L'; // .L..
				Vertro.shape[1][2] = 'L'; // .L..
			}
			else if (dir == 3)
			{
				Vertro.shape[0][0] = 'L'; // ....
				Vertro.shape[0][1] = 'L'; // ....
				Vertro.shape[1][1] = 'L'; // LLL.
				Vertro.shape[2][1] = 'L'; // L...
			}
			break;
		case 'J':
			if (dir == 0)
			{
				Vertro.shape[0][0] = 'J'; // ....
				Vertro.shape[1][0] = 'J'; // .J..
				Vertro.shape[1][1] = 'J'; // .J..
				Vertro.shape[1][2] = 'J'; // JJ..
			}
			else if (dir == 1)
			{
				Vertro.shape[0][1] = 'J'; // ....
				Vertro.shape[1][1] = 'J'; // ....
				Vertro.shape[2][0] = 'J'; // JJJ.
				Vertro.shape[2][1] = 'J'; // ..J.
			}
			else if (dir == 2)
			{
				Vertro.shape[1][0] = 'J'; // ....
				Vertro.shape[1][1] = 'J'; // .JJ.
				Vertro.shape[1][2] = 'J'; // .J..
				Vertro.shape[2][2] = 'J'; // .J..
			}
			else if (dir == 3)
			{
				Vertro.shape[0][1] = 'J'; // ....
				Vertro.shape[0][2] = 'J'; // J...
				Vertro.shape[1][1] = 'J'; // JJJ.
				Vertro.shape[2][1] = 'J'; // ....
			}
			break;
		case 'S':
			if (dir % 2 == 0)
			{
				Vertro.shape[0][0] = 'S'; // ....
				Vertro.shape[1][0] = 'S'; // ....
				Vertro.shape[1][1] = 'S'; // .SS.
				Vertro.shape[2][1] = 'S'; // SS..
			}
			else if (dir % 2 == 1)
			{
				Vertro.shape[0][1] = 'S'; // ....
				Vertro.shape[0][2] = 'S'; // S...
				Vertro.shape[1][0] = 'S'; // SS..
				Vertro.shape[1][1] = 'S'; // .S..
			}
			break;
		case 'Z':
			if (dir % 2 == 0)
			{
				Vertro.shape[0][1] = 'Z'; // ....
				Vertro.shape[1][0] = 'Z'; // ....
				Vertro.shape[1][1] = 'Z'; // ZZ..
				Vertro.shape[2][0] = 'Z'; // .ZZ.
			}
			else if (dir % 2 == 1)
			{
				Vertro.shape[0][0] = 'Z'; // ....
				Vertro.shape[0][1] = 'Z'; // .Z..
				Vertro.shape[1][1] = 'Z'; // ZZ..
				Vertro.shape[1][2] = 'Z'; // Z...
			}
	}
}

void vertro_rotate(char direction)
{
	/* Direction:
		0 Left
		1 Right */
	
	if (Vertro.type == 'O')
		return;

	if (direction == 0)
	{
		set_vertro(Vertro.type, (Vertro.dir + 1) % 4);
		if (!valid_pos(Vertro.x, Vertro.y))
			vertro_rotate(1);
	}
	else
	{
		set_vertro(Vertro.type, (Vertro.dir + 3) % 4);
		if (!valid_pos(Vertro.x, Vertro.y))
			vertro_rotate(0);
	}
}

void set_next_vertro(char type)
{
	memset(Vertro_Next.shape, 0, MAX_VERTROMINO * MAX_VERTROMINO);

	Vertro_Next.type = type;

	switch (type)
	{
		case 'I':
			Vertro_Next.shape[1][0] = 'I'; // .I...
			Vertro_Next.shape[1][1] = 'I'; // .I...
			Vertro_Next.shape[1][2] = 'I'; // .I...
			Vertro_Next.shape[1][3] = 'I'; // .I...
			break;
		case 'T':
			Vertro_Next.shape[0][2] = 'T'; // .T..
			Vertro_Next.shape[1][2] = 'T'; // TTT.
			Vertro_Next.shape[1][3] = 'T'; // ....
			Vertro_Next.shape[2][2] = 'T'; // ....
			break;
		case 'O':
			Vertro_Next.shape[0][2] = 'O'; // OO..
			Vertro_Next.shape[0][3] = 'O'; // OO..
			Vertro_Next.shape[1][2] = 'O'; // ....
			Vertro_Next.shape[1][3] = 'O'; // ....
			break;
		case 'L':
			Vertro_Next.shape[1][1] = 'L'; // .L..
			Vertro_Next.shape[1][2] = 'L'; // .L..
			Vertro_Next.shape[1][3] = 'L'; // .LL.
			Vertro_Next.shape[2][1] = 'L'; // ....
			break;
		case 'J':
			Vertro_Next.shape[0][1] = 'J'; // .J..
			Vertro_Next.shape[1][1] = 'J'; // .J..
			Vertro_Next.shape[1][2] = 'J'; // JJ..
			Vertro_Next.shape[1][3] = 'J'; // ....
			break;
		case 'S':
			Vertro_Next.shape[0][2] = 'S'; // .SS.
			Vertro_Next.shape[1][2] = 'S'; // SS..
			Vertro_Next.shape[1][3] = 'S'; // ....
			Vertro_Next.shape[2][3] = 'S'; // ....
			break;
		case 'Z':
			Vertro_Next.shape[0][3] = 'Z'; // ZZ..
			Vertro_Next.shape[1][2] = 'Z'; // .ZZ.
			Vertro_Next.shape[1][3] = 'Z'; // ....
			Vertro_Next.shape[2][2] = 'Z'; // ....
	}
}

void gen_vertro()
{
	const char vertros[] = "ITOLJSZ";

	Vertro.x = 4;
	Vertro.y = VERTRIS_H;

	set_vertro(vertros[Next_Vertro], 0);

	Next_Vertro = AL_RAND() % VERTROMINOS;

	set_next_vertro(vertros[Next_Vertro]);
}
